definition module PreludeGeneric

import Prelude
from PreludeText 	import class Show(..), ::ShowS, class Read(..), ::ReadS

:: Unit 			= Unit						// unit type; empty
:: Con a 			= Con String a				// Constructor
:: Pair a b 		= Pair a b					// product
//:: Either a b 		= Left a | Right b			// disjoint sum

instance == Unit
instance == (Con a)      | Eq a
instance == (Pair a b)   | Eq a & Eq b
instance == (Either a b) | Eq a & Eq b

instance < Unit
instance < (Con a)       | Ord a
instance < (Pair a b)    | Ord a & Ord b 
instance < (Either a b)  | Ord a & Ord b

//instance == [a] 		 | Eq  a
//instance < [a] 		 | Ord a
instance == (a,b) 		 | Eq  a & Eq  b
instance < (a,b) 		 | Ord a & Ord b
instance == (a,b,c) 	 | Eq  a & Eq  b & Eq  c
instance < (a,b,c) 		 | Ord a & Ord b & Ord c

instance Show Unit
instance Show (Con a)      | Show a
instance Show (Pair a b)   | Show a & Show b
instance Show (Either a b) | Show a & Show b

instance Read Unit
instance Read (Con a)      | Read a
instance Read (Pair a b)   | Read a & Read b
instance Read (Either a b) | Read a & Read b

shown	:: Int a 	  -> [Char] |Show a
readsn	:: Int -> ReadS a  | Read a 

class toGen source gen :: source -> gen

lexConstr :: String a -> ReadS a

instance Show Ordering
instance Show Bool
instance Show (Maybe a) | Show a
instance Show [a] 		| Show a
instance Show (a,b)  	| Show a & Show b

instance Read Ordering
instance Read Bool
instance Read (Maybe a) | Read a
instance Read [a] 		| Read a
instance Read  (a,b) 	| Read a & Read b
