definition module PreludeIO

from Prelude     import class Monad(..), class Functor(..), :: Trivial, :: Maybe(..)
from PreludeText import class Show(..),  :: ShowS(..)

import StdFile

:: StateMonad  state a  =   MkState (state -> *(a, state))

applyStateMonad     :: (StateMonad .state a) !.state -> (a, !.state)
appStateMonad       :: (*IOState -> *IOState) -> IO Trivial
accStateMonad       :: (*IOState -> *(a, *IOState)) -> IO a

instance Monad (StateMonad .state)
instance Monad IO
instance Functor IO

:: *IOState :== (*World, *File, *(Maybe *File), Maybe Error)
            //  (world, console, opened file,   errors)

:: IO a

:: Error    :== [Char] 
:: FilePath :== [Char]
:: FileMode :== Int

doIO        :: (IO a) *World -> (a, *World) // used for testing

putChar     :: Char     -> IO Trivial
putStr      :: [Char]   -> IO Trivial
putStrLn    :: [Char]   -> IO Trivial
print       :: a        -> IO Trivial | Show a

getChar     :: IO Char
getLine     :: IO [Char]
getContents :: IO [Char]
interact    :: ([Char] -> [Char]) -> IO Trivial

readFile    :: FilePath -> IO [Char]
writeFile   :: FilePath [Char] -> IO Trivial
appendFile  :: FilePath [Char] -> IO Trivial


