implementation module PreludeList

from Prelude import class Eq(..), class Num (..), class Ord (..), :: Ordering(..), :: Maybe(..), class Show
					, class ==(..),  class <(..)
					,class +(..),    class -(..),    class *(..),    class abs(..)
				    ,class zero(..),class one(..),  class exp(..),  class sin(..),  class cos(..),  class asin(..)
				    ,class acos(..),class atan(..), class sinh(..), class cosh(..), class asinh(..),class acosh(..)
				    ,class fromInt(..),             class sign(..), class toChar(..),               class fromChar(..)

from PreludeListLayer import 
    hs__map,    ###++,      hs__filter, hs__concat,     hs__head,       hs__last,       hs__tail,       hs__init,
    hs__null,   hs__length, ###!!,      hs__foldl,      hs__foldr,      hs__foldl1,     hs__foldr1,     hs__scanl,
    hs__scanr,  hs__scanl1, hs__scanr1, hs__iterate,    hs__repeat,     hs__replicate,  hs__cycle,      hs__takeWhile,
    hs__dropWhile,hs__span, hs__break,  hs__words,      hs__unlines,    hs__unwords,    hs__reverse,    hs__and,
    hs__or,     hs__any,    hs__all,    hs__elem,       hs__notElem,    hs__lookup,     hs__sum,        hs__product,
    hs__maximum,hs__minimum,hs__concatMap,hs__zip,      hs__zip3,       hs__zipWith,    hs__zipWith3,   hs__unzip,
    hs__unzip3, hs__take,   hs__drop,   hs__splitAt,hs__lines

// ====================================================================================

map :: (a -> b) ![a] -> [b] 
map f xs        = hs__map f xs

(++) infixr 5   :: ![a] [a] -> [a] 
(++) a b            = (###++) a b

filter  :: (a -> Bool) [a] -> [a] 
filter p xs     = hs__filter p xs

concat  :: ![[a]] -> [a] 
concat a        = hs__concat a

head    :: ![a] -> a 
head xs             = hs__head xs

last    :: ![a] -> a 
last xs         = hs__last xs

tail    ::  [a] -> [a]
tail xs             = hs__tail xs

init    :: ![a] -> [a]
init xs         = hs__init xs

null :: [a] -> Bool
null xs             = hs__null xs

length  :: ![a] -> Int
length xs       = hs__length xs

(!!) infixl 9 :: ![ a]  Int ->  a
(!!) li n       = (###!!) li n      

foldl :: (a b -> a) a ![b] -> a
foldl f e xs    = hs__foldl f e xs

foldl1 :: (a a -> a) ![a] -> a
foldl1 f xs = hs__foldl1 f xs

foldr :: (a b -> b) b ![a] -> b
foldr f e xs    = hs__foldr f e xs

foldr1 :: (a a -> a) ![a] -> a
foldr1 f xs     = hs__foldr1 f xs

scanl :: (a b -> a) a ![b] -> [a]
scanl f q xs   = hs__scanl f q xs

scanl1 :: (a a -> a) ![a] -> [a]
scanl1 f xs     = hs__scanl1 f xs

scanr :: (a b -> b) b ![a] -> [b]
scanr f q0 xs  = hs__scanr f q0 xs

scanr1 :: (a a -> a) ![a] -> [a]
scanr1 f xs    = hs__scanr1 f xs 

iterate :: (a -> a) a -> [a] 
iterate f x     = hs__iterate f x

repeat ::  a -> [a] 
repeat x            = hs__repeat x

replicate :: Int a -> [a]
replicate n x   = hs__replicate n x

cycle :: [a] -> [a]
cycle xs        = hs__cycle xs

take :: !Int [a] -> [a] 
take n xs       = hs__take n xs

drop :: Int ![a] -> [a]
drop n xs       = hs__drop n xs

splitAt :: !Int [a] -> ([a],[a])
splitAt n xs    = hs__splitAt n xs

takeWhile :: (a -> Bool) ![a] -> [a]
takeWhile p xs  = hs__takeWhile p xs

dropWhile :: (a -> Bool) ![a] -> [a]
dropWhile p xs  = hs__dropWhile p xs

span    :: (a -> Bool) ![a] -> ([a],[a])
span p xs       = hs__span p xs

break :: (a -> Bool) [a] -> ([a],[a]) 
break p xs      = hs__break p xs

lines :: [Char] -> [[Char]]
lines xs            = hs__lines xs

words :: [Char] -> [[Char]]
words xs            = hs__words xs

unlines :: [[Char]] -> [Char]
unlines xs      = hs__unlines xs

unwords :: [[Char]] -> [Char]
unwords xs      = hs__unwords xs

reverse :: ![a] -> [a] 
reverse xs      = hs__reverse xs

and :: ![Bool] -> Bool 
and xs          = hs__and xs

or :: ![Bool] -> Bool 
or  xs              = hs__or xs

any ::  (a -> Bool) -> ![a] -> Bool
any xs          = hs__any xs

all ::  (a -> Bool) -> ![a] -> Bool
all xs          = hs__all xs

elem :: a  [a] -> Bool | Eq a
elem e list     = hs__elem e list

notElem :: a .[a] -> Bool | Eq a
notElem e list = hs__notElem e list

lookup:: a [(a,b)] -> Maybe b | Eq a
lookup a xs     = hs__lookup a xs

sum:: ![a] -> a | Num  a
sum xs          = hs__sum xs

product :: ![a] -> a | Num a
product xs      = hs__product xs

maximum ::  ![a] -> a | Ord a
maximum xs      = hs__maximum xs

minimum ::  ![a] -> a | Ord a
minimum xs      = hs__minimum xs

concatMap :: (a-> [b]) ![a] -> [b]
concatMap f x   = hs__concatMap f x

zip::![a] [b] -> [(a,b)]
zip  x y            = hs__zip x y

/* in Clean:
zip::!(![.a],[.b]) -> [(.a,.b)]
zip (x,y) = zip2 x y
*/

zip3 :: ![a] [b] [c] -> [(a,b,c)]
zip3 al bl cl   = hs__zip3 al bl cl

zipWith :: (a b -> c) ![a] [b] -> [c]
zipWith f al bl = hs__zipWith f al bl

zipWith3 :: (a b c -> d) ![a] [b] [c] -> [d]
zipWith3 z a b c = hs__zipWith3 z a b c

unzip :: [(a,b)] -> ([a],[b]) 
unzip xs            = hs__unzip xs

unzip3 :: ![(a,b,c)] -> ([a],[b],[c])
unzip3 xs       = hs__unzip3 xs



