implementation module PreludeListLayer


from Prelude import class Eq(..), class Num (..), class Ord (..), :: Ordering(..), :: Maybe(..), class Show
                    ,max,min,/=
					,class ==(..),  class <(..),    class +(..),    class -(..),    class *(..),    class abs(..)
					,class zero(..),class one(..),  class exp(..),  class sin(..),  class cos(..),  class asin(..)
					,class acos(..),class atan(..), class sinh(..), class cosh(..), class asinh(..),class acosh(..)
					,class fromInt(..),             class sign(..), class toChar(..),               class fromChar(..)


from StdInt         import  instance + Int, instance < Int
from StdChar        import  instance == Char

from StdMisc import abort

from StdList import map, ++,filter,flatten,last,init,!!,foldr,foldl,repeat,repeatn,iterate
                    ,take,takeWhile,drop,splitAt,dropWhile,span,isEmpty,reverse,and,or,any,all,
                    zip,unzip

from StdChar import isSpace
from StdFunc import o
from StdBool import not


// ---------------------------------------------------------------------

hs__map :: (a -> b) ![a] -> [b] 
hs__map f xs =  map f xs

(###++) infixr 5 :: ![a] [a] -> [a] 
(###++) a b = (++) a b

hs__filter :: (a -> Bool) [a] -> [a] 
hs__filter p xs = filter p xs

hs__concat :: ![[a]] -> [a] 
hs__concat a = flatten a

hs__head :: ![a] -> a 
hs__head [a:x]  = a
hs__head []     = abort "head of []"

hs__last :: ![a] -> a 
hs__last xs =   last xs

hs__tail :: [a] -> [a]
hs__tail [a:x]  = x
hs__tail []     = abort "tail of []"

hs__init :: ![a] -> [a]
hs__init xs =   init xs

hs__null :: [a] -> Bool
hs__null []     = True
hs__null [x:xs]   = False

hs__length  :: ![a] -> Int
hs__length []       =   0
hs__length [_:l]    =   1 + hs__length l

(###!!) infixl 9 :: ![ a]  Int ->  a
(###!!) li n    =   (!!) li n       

hs__foldl :: (a b -> a) a ![b] -> a
hs__foldl f e xs    =   foldl f e xs

hs__foldl1 :: (a a -> a) ![a] -> a
hs__foldl1 f [x:xs] = foldl f x xs
hs__foldl1 _ []     = abort "foldl1 of []"

hs__foldr :: (a b -> b) b ![a] -> b
hs__foldr f e xs    =   foldr f e xs

hs__foldr1 :: (a a -> a) ![a] -> a
hs__foldr1 f [x]    = x
hs__foldr1 f [x:xs] = f x (hs__foldr1 f xs)
hs__foldr1 _ []     = abort "foldr1 of []"

hs__scanl :: (a b -> a) a ![b] -> [a]
hs__scanl f q xs      = [ q : t]
    where t = case xs of
                []          -> []
                [x:xs]  -> hs__scanl f (f q x) xs

hs__scanl1 :: (a a -> a) ![a] -> [a]
hs__scanl1 f [x:xs] = hs__scanl f x xs
hs__scanl1 _ []     = abort "scanl1 of []"

hs__scanr :: (a b -> b) b ![a] -> [b]
hs__scanr f q0 []     = [q0]
hs__scanr f q0 [x:xs] = [f x q : qs ]
    where   
        qs  = hs__scanr f q0 xs
        q   = hs__head qs   

hs__scanr1 :: (a a -> a) ![a] -> [a]
hs__scanr1 f [x]        = [x]
hs__scanr1 f [x:xs] = [f x q : qs ]
    where   
        qs  = hs__scanr1 f xs
        q   = hs__head qs   
hs__scanr1 _ []     = abort "scanr1 of []"

hs__iterate :: (a -> a) a -> [a] 
hs__iterate f x =   iterate f x

hs__repeat ::  a -> [a] 
hs__repeat x    =   repeat x

hs__replicate :: Int a -> [a]
hs__replicate n x = repeatn n x

hs__cycle :: [a] -> [a]
hs__cycle [] = abort "cycle of []"
hs__cycle xs = xs1
            where xs1   =   xs ++ xs1

hs__take :: !Int [a] -> [a] 
hs__take n xs   
    | n<0   = abort "take: negative argument"
                = take n xs

hs__drop :: Int ![a] -> [a]
hs__drop n xs   
    | n<0   = abort "drop: negative argument"
                = drop n xs

hs__splitAt :: !Int [a] -> ([a],[a])
hs__splitAt n xs    
    | n<0   = abort "splitAt: negative argument"
                = splitAt n xs

hs__takeWhile ::(a -> Bool) ![a] -> [a]
hs__takeWhile f xs =    takeWhile f xs

hs__dropWhile :: (a -> Bool) ![a] -> [a]
hs__dropWhile f xs = dropWhile f xs 

hs__span    :: (a -> Bool) ![a] -> ([a],[a])
hs__span p xs       = span p xs

hs__break :: (a -> Bool) [a] -> ([a],[a]) 
hs__break p l = span (not o p) l

hs__lines :: [Char] -> [[Char]]
hs__lines []   = []
hs__lines s    = [ w : remain ]
    where 
        (w,s1) = hs__break ((==) '\n') s
        remain = 
            case s1 of
                []      -> []
                [_:s2]  -> hs__lines s2
            //   ^ '\n'

hs__words :: [Char] -> [[Char]]
hs__words s    
    | isEmpty s1    = [] 
                        = [w : hs__words s2]
        where   
            (w,s2)  = hs__break isSpace s1
            s1          = dropWhile isSpace s

hs__unlines :: [[Char]] -> [Char]
hs__unlines  lines = hs__foldr1 ( \ x s -> x ++ ['\n'] ++ s ) lines  

hs__unwords :: [[Char]] -> [Char]
hs__unwords words = hs__foldr1 ( \ x s -> x ++ [' '] ++ s ) words

hs__reverse :: ![a] -> [a] 
hs__reverse xs  =   reverse xs

hs__and :: ![Bool] -> Bool 
hs__and xs  =   and xs

hs__or :: ![Bool] -> Bool 
hs__or  xs  =   or xs

hs__any ::  (a -> Bool) -> ![a] -> Bool
hs__any xs  =   any xs

hs__all ::  (a -> Bool) -> ![a] -> Bool
hs__all xs  =   all xs

hs__elem :: a  [a] -> Bool | Eq a
hs__elem e list = hs__any ((==) e ) list

hs__notElem :: a .[a] -> Bool | Eq a
hs__notElem e list = hs__all ((/=) e) list

hs__lookup:: a [(a,b)] -> Maybe b | Eq a
hs__lookup key []   =   Nothing
hs__lookup key [(x,y) : xys]    
    | x == key  =   Just y
                    =   hs__lookup key xys

hs__sum:: ![a] -> a | Num  a
hs__sum xs = accsum xs zero
where
    //accsum :: ![a] !a -> a | + a;
    accsum [x:xs] n = accsum xs (n + x)
    accsum []     n = n

hs__product :: ![a] -> a | Num a
hs__product xs = accprod one xs
  where
    accprod n [x:xs] = accprod (n * x) xs
    accprod n []     = n

hs__maximum ::  ![a] -> a | Ord a
hs__maximum []  = abort "maximum of []"
hs__maximum xs  = hs__foldl1 max xs

hs__minimum ::  ![a] -> a | Ord a
hs__minimum []  = abort "minimum of []"
hs__minimum xs = hs__foldl1 min xs

hs__concatMap :: (a-> [b]) ![a] -> [b]
hs__concatMap f x = flatten (map f x)

hs__zip::![a] [b] -> [(a,b)]
hs__zip  x y = zip (x,y)

/* in Clean:
zip::!(![.a],[.b]) -> [(.a,.b)]
zip (x,y) = zip2 x y
*/

hs__zip3 :: ![a] [b] [c] -> [(a,b,c)]
hs__zip3 al bl cl = hs__zipWith3 (\ax bx cx -> (ax,bx,cx)) al bl cl

hs__zipWith :: (a b -> c) ![a] [b] -> [c]
hs__zipWith z [a:as] [b:bs] =   [z a b : hs__zipWith z as bs ]
hs__zipWith _ _      _      =   []

hs__zipWith3 :: (a b c -> d) ![a] [b] [c] -> [d]
hs__zipWith3 z [a:as] [b:bs] [c:cs] =   [z a b c : hs__zipWith3 z as bs cs]
hs__zipWith3 _ _      _      _      =   []

hs__unzip :: [(a,b)] -> ([a],[b]) 
hs__unzip xs    = unzip xs

hs__unzip3 :: ![(a,b,c)] -> ([a],[b],[c])
hs__unzip3 []       =   ([],[],[])
hs__unzip3 [(a,b,c): abcs] = ([a:as],[b:bs],[c:cs])
    where   (as,bs,cs)  =   hs__unzip3 abcs

